"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.searchCompare = exports.removeAccent = exports.latinaNoAccent = exports.latinaAccent = exports.vietnamNoAccentLower = exports.vietnamAccentLower = exports.vietnamNoAccentUpper = exports.vietnamAccentUpper = void 0;
exports.vietnamAccentUpper = "ĂÂÀÁẢÃẠẰẮẲẴẶẦẤẨẪẬÔƠÒÓỎÕỌỒỐỔỖỘỜỚỞỠỢÈÉẺẼẸÊỀẾỂỄỆÙÚỦŨỤƯỪỨỬỮỰÌÍỈĨỊỲÝỶỸỴĐ";
exports.vietnamNoAccentUpper = "AAAAAAAAAAAAAAAAAOOOOOOOOOOOOOOOOOEEEEEEEEEEEUUUUUUUUUUUIIIIIYYYYYD";
exports.vietnamAccentLower = exports.vietnamAccentUpper.toLowerCase();
exports.vietnamNoAccentLower = exports.vietnamNoAccentUpper.toLowerCase();
exports.latinaAccent = "ŠšŽžÄÅÆÇËÎÏÑÖØÛÜŸÞäåæçëîïñõöøûüÿþƒ";
exports.latinaNoAccent = "SsZzAAACEIINOOUUYBaaaceiinooouuybf";
const accentCharsets = [
    { accent: exports.vietnamAccentUpper, noAccent: exports.vietnamNoAccentUpper },
    { accent: exports.vietnamAccentLower, noAccent: exports.vietnamNoAccentLower },
    { accent: exports.latinaAccent, noAccent: exports.latinaNoAccent },
];
const removeAccent = (data) => {
    let result = "";
    for (let i = 0; i < data.length; i++) {
        let character = data[i];
        for (const charset of accentCharsets) {
            const indexOf = charset.accent.indexOf(character);
            if (indexOf >= 0) {
                character = charset.noAccent[indexOf];
                break;
            }
        }
        result += character;
    }
    return result;
};
exports.removeAccent = removeAccent;
const searchCompare = (value, search, ignoreValueAccent = true) => {
    return (ignoreValueAccent ? (0, exports.removeAccent)(value) : value).toLowerCase().includes((0, exports.removeAccent)(search).toLowerCase());
};
exports.searchCompare = searchCompare;
