"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AccessConditionValueType = void 0;
var AccessConditionValueType;
(function (AccessConditionValueType) {
    /**
     * Any string value. Constraint is a regex.
     */
    AccessConditionValueType["STRING"] = "STRING";
    /**
     * Numerical value. Constraint is {from: number, to: number, integer: boolean} encoded into string.
     */
    AccessConditionValueType["NUMBER"] = "NUMBER";
    /**
     * Yes or No. No constraint.
     */
    AccessConditionValueType["BOOLEAN"] = "BOOLEAN";
    /**
     * An unlimited list of string values. Constraint is whether emptiness is allowed.
     */
    AccessConditionValueType["LIST"] = "LIST";
    /**
     * A list of choices. Constraint is the list of choices.
     */
    AccessConditionValueType["CHOICES"] = "CHOICES";
    /**
     * A list of mutual exclusive choices. Constraint is the list of choices.
     */
    AccessConditionValueType["MUTEXCHOICES"] = "MUTEXCHOICES";
    /**
     * And DtoMetadata that validates an data object. Constraint is the information of dto fields.
     */
    AccessConditionValueType["DTO"] = "DTO";
})(AccessConditionValueType = exports.AccessConditionValueType || (exports.AccessConditionValueType = {}));
