"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetManyQueriesClass = exports.GetManyResponseBodyClass = exports.getUpdateRecordsBodyValidator = exports.getUpdateRecordsQueryValidator = exports.getUpdateManyResponseValidator = exports.getUpdateManyBodyValidator = exports.getUpdateManyQueryValidator = exports.getGetManyQueryValidator = exports.queryFieldDto = exports.getRequestQueryFieldFromModel = exports.projectionFieldDto = exports.getBodyDtoRecordClass = exports.getGetManyResponseValidator = exports.getCreateManyResponseValidator = exports.getCreateManyBodyValidator = void 0;
const DataType_1 = require("../common/DataType");
const metadata_1 = require("../common/metadata");
const decorator_1 = require("../dto/decorator");
const deep_partial_1 = require("../dto/deep-partial");
const request_response_1 = require("./request-response");
const decorator_2 = require("../dto/decorator");
const RangeQueryDto_1 = require("./RangeQueryDto");
const getCreateManyBodyValidator = (modelMetadata) => {
    //-- body ------------------------------------
    const bodyDto = { id: "", fields: [] };
    const fieldMetadata = {};
    fieldMetadata.name = "records";
    fieldMetadata.description = "Array of records to be created.";
    fieldMetadata.dataType = DataType_1.DataType.ARRAY;
    fieldMetadata.isRequired = true;
    fieldMetadata.vectorProps = {
        elementDataType: DataType_1.DataType.OBJECT,
        minLength: 0,
    };
    fieldMetadata.elementDto = (0, exports.getBodyDtoRecordClass)(modelMetadata, "create_body");
    bodyDto.fields.push(fieldMetadata);
    return bodyDto;
};
exports.getCreateManyBodyValidator = getCreateManyBodyValidator;
const getCreateManyResponseValidator = (modelMetadata) => {
    const bodyDto = { id: "", fields: [] };
    //-- records
    const recordsFieldMetadata = {};
    recordsFieldMetadata.name = "records";
    recordsFieldMetadata.description = "Array of records had just been created.";
    recordsFieldMetadata.dataType = DataType_1.DataType.ARRAY;
    recordsFieldMetadata.isRequired = true;
    recordsFieldMetadata.vectorProps = {
        elementDataType: DataType_1.DataType.OBJECT,
        minLength: 0,
    };
    recordsFieldMetadata.elementDto = (0, exports.getBodyDtoRecordClass)(modelMetadata, "create_response");
    bodyDto.fields.push(recordsFieldMetadata);
    return bodyDto;
};
exports.getCreateManyResponseValidator = getCreateManyResponseValidator;
const getGetManyResponseValidator = (modelMetadata) => {
    const bodyDto = { id: "", fields: [] };
    //-- total
    const totalFieldMetadata = {};
    totalFieldMetadata.name = "total";
    totalFieldMetadata.description = "Number of records found, zero is returned if the request is not paged.";
    totalFieldMetadata.dataType = DataType_1.DataType.NUMBER;
    totalFieldMetadata.isRequired = true;
    bodyDto.fields.push(totalFieldMetadata);
    //-- records
    const recordsFieldMetadata = {};
    recordsFieldMetadata.name = "records";
    recordsFieldMetadata.description = "The found records. All records will be returned if the request is not paged.";
    recordsFieldMetadata.dataType = DataType_1.DataType.ARRAY;
    recordsFieldMetadata.isRequired = true;
    recordsFieldMetadata.vectorProps = {
        elementDataType: DataType_1.DataType.OBJECT,
        minLength: 0,
    };
    recordsFieldMetadata.elementDto = (0, exports.getBodyDtoRecordClass)(modelMetadata, "get_response");
    bodyDto.fields.push(recordsFieldMetadata);
    return bodyDto;
};
exports.getGetManyResponseValidator = getGetManyResponseValidator;
const getBodyDtoRecordClass = (modelMetadata, operation, parentModelMetadata) => {
    const instanceDtoMetadata = { id: "", fields: [] };
    let baseFields = modelMetadata.fields.filter((f) => !f.hasMany && !f.multiLocaleColumn);
    if (operation === "create_response") {
        baseFields = baseFields.filter((field) => field.pk ||
            field.serverValue ||
            field.mimeProps ||
            (!field.isRequired && field.defaultValue !== undefined));
    }
    if (operation === "create_body" || operation === "update_body") {
        baseFields = baseFields.filter((field) => {
            var _a;
            //-- a normal field
            return (!field.serverValue && !((_a = field.pk) === null || _a === void 0 ? void 0 : _a.isAutoIncrement)) ||
                //-- model repository has already applied parent id to this field, so exclude it here
                (!!parentModelMetadata && !parentModelMetadata.fields.find((f) => { var _a; return ((_a = f.hasMany) === null || _a === void 0 ? void 0 : _a.column) === field.name; }));
        });
    }
    const localeFields = modelMetadata.fields.filter((field) => field.multiLocaleColumn);
    const hasManyFields = modelMetadata.fields.filter((field) => !!field.hasMany);
    instanceDtoMetadata.fields.push(...baseFields.map((field) => (Object.assign(Object.assign({}, field), { elementDto: field.elementDto && (operation === "update_body" ? (0, deep_partial_1.partialize)(field.elementDto) : field.elementDto), isRequired: operation === "query" ||
            operation === "update_body" ||
            (operation === "get_response" && !parentModelMetadata)
            ? false
            : field.isRequired && !field.isMultiLocale }))), ...hasManyFields.map((field) => {
        var _a, _b, _c, _d;
        const elementDto = (0, exports.getBodyDtoRecordClass)(field.hasMany.relationDto, operation, modelMetadata);
        return {
            description: `All records of "${(_a = field.hasMany) === null || _a === void 0 ? void 0 : _a.relationDto.id}" table in this relationship.`,
            name: field.name,
            dataType: ((_b = field.hasMany) === null || _b === void 0 ? void 0 : _b.single) ? DataType_1.DataType.OBJECT : DataType_1.DataType.ARRAY,
            isRequired: !((_c = field.hasMany) === null || _c === void 0 ? void 0 : _c.single) && operation === "create_response",
            vectorProps: ((_d = field.hasMany) === null || _d === void 0 ? void 0 : _d.single)
                ? undefined
                : {
                    elementDataType: DataType_1.DataType.OBJECT,
                    minLength: 0,
                },
            elementDto: Object.assign(Object.assign({}, elementDto), { fields: 
                //-- if update / create then the pk column in has many relationship is automatically resolved
                (operation === "create_body" || operation === "update_body"
                    ? elementDto.fields.filter((f) => { var _a; return f.name !== ((_a = field.hasMany) === null || _a === void 0 ? void 0 : _a.column); })
                    : elementDto.fields).map((f) => (operation === "update_body" ? Object.assign(Object.assign({}, f), { isRequired: false, allowNull: true }) : f)) }),
        };
    }), ...localeFields.map((field) => {
        return {
            description: "Translation for " + field.multiLocaleColumn,
            name: field.name,
            isRequired: false,
            dataType: DataType_1.DataType.OBJECT,
        };
    }));
    return instanceDtoMetadata;
};
exports.getBodyDtoRecordClass = getBodyDtoRecordClass;
const projectionFieldDto = (modelMetadata) => {
    const dto = {};
    dto.name = "projection";
    dto.description = "Project the returning records to contain only certain fields. Omit to return all.";
    dto.dataType = DataType_1.DataType.ARRAY;
    dto.vectorProps = {
        superSet: modelMetadata.fields.map((field) => field.name),
        allowDuplicated: false,
        minLength: 1,
        elementDataType: DataType_1.DataType.STRING,
    };
    return dto;
};
exports.projectionFieldDto = projectionFieldDto;
const getRequestQueryFieldFromModel = (modelMetadata) => {
    return modelMetadata.fields.map((modelFieldMetadata) => {
        const queryFieldMedata = {};
        queryFieldMedata.name = modelFieldMetadata.name;
        queryFieldMedata.description = modelFieldMetadata.description;
        queryFieldMedata.isRequired = false;
        if (modelFieldMetadata.pk || modelFieldMetadata.fk || modelFieldMetadata.isSymbol) {
            //-- if is PK or FK then allow to search by array of ids
            queryFieldMedata.dataType = DataType_1.DataType.ARRAY;
            queryFieldMedata.vectorProps = {
                elementDataType: modelFieldMetadata.dataType,
                allowDuplicated: false,
                allowNull: modelFieldMetadata.allowNull,
                minLength: 1,
            };
        }
        else if (modelFieldMetadata.hasMany) {
            const dto = {
                id: "",
                fields: (0, exports.getRequestQueryFieldFromModel)(modelFieldMetadata.hasMany.relationDto).filter((f) => { var _a; return f.name !== ((_a = modelFieldMetadata.hasMany) === null || _a === void 0 ? void 0 : _a.column); }),
            };
            dto.relaxed = true;
            queryFieldMedata.dataType = DataType_1.DataType.OBJECT;
            queryFieldMedata.elementDto = dto;
        }
        else {
            if (modelFieldMetadata.enum) {
                queryFieldMedata.dataType = DataType_1.DataType.ARRAY;
                queryFieldMedata.vectorProps = {
                    superSet: modelFieldMetadata.enum,
                    allowDuplicated: false,
                    minLength: 1,
                    elementDataType: modelFieldMetadata.enum.filter((v) => typeof v === "number").length
                        ? DataType_1.DataType.NUMBER
                        : DataType_1.DataType.STRING,
                    allowNull: modelFieldMetadata.allowNull,
                };
            }
            else {
                switch (modelFieldMetadata.dataType) {
                    case DataType_1.DataType.STRING:
                        // to be processed as regex in database adapter
                        queryFieldMedata.dataType = DataType_1.DataType.STRING;
                        break;
                    case DataType_1.DataType.NUMBER:
                        queryFieldMedata.dataType = DataType_1.DataType.OBJECT;
                        queryFieldMedata.elementDto = (0, metadata_1.getObjectMetadata)(RangeQueryDto_1.RangeQueryDto);
                        break;
                    case DataType_1.DataType.BOOLEAN:
                        queryFieldMedata.dataType = DataType_1.DataType.BOOLEAN;
                        queryFieldMedata.allowNull = modelFieldMetadata.allowNull;
                        break;
                }
            }
        }
        return queryFieldMedata;
    });
};
exports.getRequestQueryFieldFromModel = getRequestQueryFieldFromModel;
const queryFieldDto = (modelMetadata) => {
    const fieldsDtoMetadata = {
        id: "",
        fields: (0, exports.getRequestQueryFieldFromModel)(modelMetadata),
    };
    const field = {};
    field.name = "fields";
    field.description = "Filter records by value of their fields.";
    field.dataType = DataType_1.DataType.OBJECT;
    field.elementDto = fieldsDtoMetadata;
    return field;
};
exports.queryFieldDto = queryFieldDto;
const getGetManyQueryValidator = (modelMetadata) => {
    //-- fields query
    const queryDto = {
        id: "",
        fields: [(0, exports.queryFieldDto)(modelMetadata)],
    };
    //-- locale query
    const localeDto = {};
    localeDto.name = "locale";
    localeDto.description = "Language code for localization";
    localeDto.isRequired = false;
    localeDto.dataType = DataType_1.DataType.STRING;
    queryDto.fields.push(localeDto);
    //-- search query ---------------------------------------------------
    const searchDto = {};
    searchDto.name = "search";
    searchDto.description = "Filter records for their @Searchable denoted fields.";
    searchDto.dataType = DataType_1.DataType.STRING;
    queryDto.fields.push(searchDto);
    //-- projection query ---------------------------------------------------
    queryDto.fields.push((0, exports.projectionFieldDto)(modelMetadata));
    //-- order query ---------------------------------------------------
    const sortDto = {};
    sortDto.name = "order";
    sortDto.description =
        "Sort the dataset before getting result by order given in the array. Field appears first in the array will be sorted first.";
    sortDto.dataType = DataType_1.DataType.ARRAY;
    sortDto.vectorProps = {
        elementDataType: DataType_1.DataType.OBJECT,
        minLength: 1,
    };
    //-- Dynamic value for decorator is not allowed, so we create
    //-- and inject metadata object to class to be retrieved later by validator.
    const sortElementDtoMetadata = { id: "", fields: [] };
    sortElementDtoMetadata.fields.push(...modelMetadata.fields
        .filter((f) => !f.hasMany)
        .map((field) => {
        const fieldMetadata = {};
        fieldMetadata.name = field.name;
        fieldMetadata.isRequired = false;
        fieldMetadata.dataType = DataType_1.DataType.STRING;
        fieldMetadata.enum = ["asc", "desc"];
        return fieldMetadata;
    }));
    sortDto.elementDto = sortElementDtoMetadata;
    queryDto.fields.push(sortDto);
    //-- limit query ---------------------------------------------------
    const limitDto = {};
    limitDto.name = "limit";
    limitDto.description = "Limit the number of returning result.";
    limitDto.dataType = DataType_1.DataType.NUMBER;
    limitDto.rangeProps = {
        min: 1,
    };
    queryDto.fields.push(limitDto);
    //-- page query ---------------------------------------------------
    const pageDto = {};
    pageDto.name = "page";
    pageDto.description = "Page the returning result, default to 1 if ommited. Has no effect if limit is not set.";
    pageDto.dataType = DataType_1.DataType.NUMBER;
    pageDto.rangeProps = {
        min: 1,
    };
    queryDto.fields.push(pageDto);
    return queryDto;
};
exports.getGetManyQueryValidator = getGetManyQueryValidator;
const getRetuningFieldMetadata = () => {
    const returningField = {};
    returningField.name = "returning";
    returningField.description = "Whether to return the affected records by this request.";
    returningField.dataType = DataType_1.DataType.BOOLEAN;
    returningField.isRequired = false;
    return returningField;
};
const getUpdateManyQueryValidator = (modelMetadata) => {
    return {
        id: "",
        fields: [getRetuningFieldMetadata(), (0, exports.queryFieldDto)(modelMetadata)],
    };
};
exports.getUpdateManyQueryValidator = getUpdateManyQueryValidator;
const getUpdateManyBodyValidator = (modelMetadata) => {
    const bodyDto = { id: "", fields: [] };
    const fieldMetadata = {};
    fieldMetadata.name = "update";
    fieldMetadata.isRequired = true;
    fieldMetadata.description = "The update data to apply to found records.";
    fieldMetadata.dataType = DataType_1.DataType.OBJECT;
    fieldMetadata.elementDto = (0, exports.getBodyDtoRecordClass)(modelMetadata, "update_body");
    bodyDto.fields.push(fieldMetadata);
    return bodyDto;
};
exports.getUpdateManyBodyValidator = getUpdateManyBodyValidator;
const getUpdateManyResponseValidator = (modelMetadata) => {
    const bodyDto = { id: "", fields: [] };
    const fieldMetadata = {};
    fieldMetadata.name = "modified";
    fieldMetadata.description = "Array of affected records.";
    fieldMetadata.dataType = DataType_1.DataType.ARRAY;
    fieldMetadata.vectorProps = { minLength: 0, elementDataType: DataType_1.DataType.OBJECT };
    fieldMetadata.elementDto = fieldMetadata.elementDto = (0, exports.getBodyDtoRecordClass)(modelMetadata, "get_response");
    bodyDto.fields.push(fieldMetadata);
    return bodyDto;
};
exports.getUpdateManyResponseValidator = getUpdateManyResponseValidator;
const getUpdateRecordsQueryValidator = () => {
    return {
        id: "",
        fields: [getRetuningFieldMetadata()],
    };
};
exports.getUpdateRecordsQueryValidator = getUpdateRecordsQueryValidator;
const getUpdateRecordsBodyValidator = (modelMetadata) => {
    const bodyDto = { id: "", fields: [] };
    const fieldMetadata = {};
    fieldMetadata.name = "records";
    fieldMetadata.isRequired = true;
    fieldMetadata.description = "The records with id and data to update";
    fieldMetadata.dataType = DataType_1.DataType.ARRAY;
    fieldMetadata.vectorProps = { minLength: 0, elementDataType: DataType_1.DataType.OBJECT };
    fieldMetadata.elementDto = (0, exports.getBodyDtoRecordClass)(modelMetadata, "update_body");
    //-- each update record must contain id field
    fieldMetadata.elementDto.fields.push({
        name: "id",
        dataType: DataType_1.DataType.STRING,
        isRequired: true,
    });
    bodyDto.fields.push(fieldMetadata);
    return bodyDto;
};
exports.getUpdateRecordsBodyValidator = getUpdateRecordsBodyValidator;
const GetManyResponseBodyClass = (cls) => {
    let _ = class _ extends request_response_1.GetManyResponseBody {
    };
    _ = __decorate([
        (0, decorator_1.Data)()
    ], _);
    const newMetadata = (0, metadata_1.getObjectMetadata)(_);
    const recordsMeta = newMetadata.fields.find((field) => field.name === "records");
    if (recordsMeta) {
        recordsMeta.elementDto = (0, decorator_2.ElementDto)((0, deep_partial_1.DeepPartialClass)(cls)).elementDto;
    }
    return _;
};
exports.GetManyResponseBodyClass = GetManyResponseBodyClass;
const GetManyQueriesClass = (cls) => {
    let _ = class _ extends request_response_1.GetManyQueries {
    };
    _ = __decorate([
        (0, decorator_1.Data)()
    ], _);
    (0, metadata_1.setObjectMetadata)(_, (0, exports.getGetManyQueryValidator)((0, metadata_1.getObjectMetadata)(cls)));
    return _;
};
exports.GetManyQueriesClass = GetManyQueriesClass;
