"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApiInfoResponse = exports.Permission = void 0;
const DataType_1 = require("../common/DataType");
const metadata_1 = require("../common/metadata");
const decorator_1 = require("../dto/decorator");
const decorator_2 = require("../dto/decorator");
const AccessConditionMetadata_1 = require("./AccessConditionMetadata");
const HttpMethod_1 = require("./HttpMethod");
let Permission = class Permission {
};
__decorate([
    (0, decorator_2.Field)({
        description: "Id of the permission",
        isRequired: true,
    }),
    __metadata("design:type", String)
], Permission.prototype, "id", void 0);
__decorate([
    (0, decorator_2.Field)({
        description: "Description of the permission",
    }),
    __metadata("design:type", String)
], Permission.prototype, "description", void 0);
__decorate([
    (0, decorator_2.Field)({
        description: "Display name of the permission",
        isRequired: true,
    }),
    __metadata("design:type", String)
], Permission.prototype, "name", void 0);
__decorate([
    (0, decorator_2.Field)({
        description: "Whether this permission has public access",
        isRequired: true,
    }),
    __metadata("design:type", Boolean)
], Permission.prototype, "openAccess", void 0);
__decorate([
    (0, decorator_2.Field)({
        description: "Whether this permission require tfa",
        isRequired: true,
    }),
    __metadata("design:type", Boolean)
], Permission.prototype, "tfaRequired", void 0);
__decorate([
    (0, decorator_2.Field)({
        description: "Name of the permission group",
        isRequired: true,
    }),
    __metadata("design:type", String)
], Permission.prototype, "permissionGroup", void 0);
__decorate([
    (0, decorator_2.Field)({
        description: "The configurable access condition of this permission",
        isRequired: true,
        vectorProps: {},
        elementDto: (0, metadata_1.getObjectMetadata)(AccessConditionMetadata_1.AccessConditionMetadata),
    }),
    __metadata("design:type", Array)
], Permission.prototype, "accessConditions", void 0);
__decorate([
    (0, decorator_2.Field)({
        description: "Whether this permission does not allow data modification",
        isRequired: true,
    }),
    __metadata("design:type", Boolean)
], Permission.prototype, "readOnly", void 0);
__decorate([
    (0, decorator_2.Field)(Object.assign({ description: "Http method used to call the API", isRequired: true }, (0, decorator_1.Enum)(HttpMethod_1.HttpMethod))),
    __metadata("design:type", String)
], Permission.prototype, "method", void 0);
__decorate([
    (0, decorator_2.Field)({
        description: "Http Mount point of the API",
        isRequired: true,
    }),
    __metadata("design:type", String)
], Permission.prototype, "mount", void 0);
__decorate([
    (0, decorator_2.Field)({
        description: "Validation dto of request param",
    }),
    __metadata("design:type", Object)
], Permission.prototype, "paramDto", void 0);
__decorate([
    (0, decorator_2.Field)({
        description: "Validation dto of request queries",
    }),
    __metadata("design:type", Object)
], Permission.prototype, "queryDto", void 0);
__decorate([
    (0, decorator_2.Field)({
        description: "Validation dto of request body (for POST / PUT)",
    }),
    __metadata("design:type", Object)
], Permission.prototype, "bodyDto", void 0);
__decorate([
    (0, decorator_2.Field)({
        description: "Validation dto of response body",
    }),
    __metadata("design:type", Object)
], Permission.prototype, "responseDto", void 0);
Permission = __decorate([
    (0, decorator_2.Data)()
], Permission);
exports.Permission = Permission;
let ApiInfoResponse = class ApiInfoResponse {
};
__decorate([
    (0, decorator_2.Field)({
        description: "All permissions of the service",
        isRequired: true,
        elementDto: (0, metadata_1.getObjectMetadata)(Permission),
        vectorProps: { elementDataType: DataType_1.DataType.OBJECT },
    }),
    __metadata("design:type", Array)
], ApiInfoResponse.prototype, "permissions", void 0);
ApiInfoResponse = __decorate([
    (0, decorator_2.Data)()
], ApiInfoResponse);
exports.ApiInfoResponse = ApiInfoResponse;
