"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UpdateRecordsBody = exports.UpdateManyBody = exports.UpdateManyResponse = exports.UpdateManyQueries = exports.GetManyResponseBody = exports.GetManyQueries = exports.ReturningQueries = exports.LocaleQueries = exports.SearchQueries = exports.PaginationQueries = exports.IdParam = exports.CreateManyResponseBody = exports.CreateManyRequestBody = exports.FieldsQuery = void 0;
const DataType_1 = require("../common/DataType");
const decorator_1 = require("../dto/decorator");
const combine_1 = require("../dto/combine");
let FieldsQuery = class FieldsQuery {
};
__decorate([
    (0, decorator_1.Field)({
        description: "Filter records by fields.",
    }),
    __metadata("design:type", Object)
], FieldsQuery.prototype, "fields", void 0);
FieldsQuery = __decorate([
    (0, decorator_1.Data)({ relaxed: true })
], FieldsQuery);
exports.FieldsQuery = FieldsQuery;
//-- create
let CreateManyRequestBody = class CreateManyRequestBody {
    constructor() {
        this.records = [];
    }
};
__decorate([
    (0, decorator_1.Field)({
        description: "Records to create",
        isRequired: true,
        vectorProps: { minLength: 1 },
    }),
    __metadata("design:type", Array)
], CreateManyRequestBody.prototype, "records", void 0);
CreateManyRequestBody = __decorate([
    (0, decorator_1.Data)()
], CreateManyRequestBody);
exports.CreateManyRequestBody = CreateManyRequestBody;
let CreateManyResponseBody = class CreateManyResponseBody {
    constructor() {
        this.records = [];
    }
};
__decorate([
    (0, decorator_1.Field)({
        description: "Returned records",
        isRequired: true,
    }),
    __metadata("design:type", Array)
], CreateManyResponseBody.prototype, "records", void 0);
CreateManyResponseBody = __decorate([
    (0, decorator_1.Data)()
], CreateManyResponseBody);
exports.CreateManyResponseBody = CreateManyResponseBody;
let IdParam = class IdParam {
};
__decorate([
    (0, decorator_1.Field)({
        description: "Id of the record",
        isRequired: true,
    }),
    __metadata("design:type", String)
], IdParam.prototype, "id", void 0);
IdParam = __decorate([
    (0, decorator_1.Data)({ relaxed: true })
], IdParam);
exports.IdParam = IdParam;
let PaginationQueries = class PaginationQueries {
};
__decorate([
    (0, decorator_1.Field)({
        description: "Limit the result.",
        rangeProps: { min: 1 },
    }),
    __metadata("design:type", Number)
], PaginationQueries.prototype, "limit", void 0);
__decorate([
    (0, decorator_1.Field)({
        description: "Paging the result.",
        rangeProps: { min: 1 },
    }),
    __metadata("design:type", Number)
], PaginationQueries.prototype, "page", void 0);
PaginationQueries = __decorate([
    (0, decorator_1.Data)({ relaxed: true })
], PaginationQueries);
exports.PaginationQueries = PaginationQueries;
let SearchQueries = class SearchQueries {
};
__decorate([
    (0, decorator_1.Field)({
        description: "Search value for searchable fields.",
    }),
    __metadata("design:type", String)
], SearchQueries.prototype, "search", void 0);
SearchQueries = __decorate([
    (0, decorator_1.Data)({ relaxed: true })
], SearchQueries);
exports.SearchQueries = SearchQueries;
let LocaleQueries = class LocaleQueries {
};
__decorate([
    (0, decorator_1.Field)({
        description: "Language code",
    }),
    __metadata("design:type", String)
], LocaleQueries.prototype, "locale", void 0);
LocaleQueries = __decorate([
    (0, decorator_1.Data)({ relaxed: true })
], LocaleQueries);
exports.LocaleQueries = LocaleQueries;
let ReturningQueries = class ReturningQueries {
};
__decorate([
    (0, decorator_1.Field)({
        description: "Whether to return ids of modified instances",
    }),
    __metadata("design:type", Boolean)
], ReturningQueries.prototype, "returning", void 0);
ReturningQueries = __decorate([
    (0, decorator_1.Data)({ relaxed: true })
], ReturningQueries);
exports.ReturningQueries = ReturningQueries;
let GetManyQueries = class GetManyQueries extends (0, combine_1.select)(PaginationQueries).combine(SearchQueries).combine(LocaleQueries).get() {
};
__decorate([
    (0, decorator_1.Field)({
        description: "Filter records by fields.",
    }),
    __metadata("design:type", Object)
], GetManyQueries.prototype, "fields", void 0);
__decorate([
    (0, decorator_1.Field)({
        description: "Order the result by fields.",
        rangeProps: { min: 1 },
    }),
    __metadata("design:type", Object)
], GetManyQueries.prototype, "order", void 0);
__decorate([
    (0, decorator_1.Field)({
        description: "Only return fields in this projection array.",
        vectorProps: { minLength: 1 },
    }),
    __metadata("design:type", Array)
], GetManyQueries.prototype, "projection", void 0);
GetManyQueries = __decorate([
    (0, decorator_1.Data)({ relaxed: true })
], GetManyQueries);
exports.GetManyQueries = GetManyQueries;
let GetManyResponseBody = class GetManyResponseBody {
    constructor() {
        this.records = [];
    }
};
__decorate([
    (0, decorator_1.Field)({
        description: "Total number of found records.",
        isRequired: true,
    }),
    __metadata("design:type", Number)
], GetManyResponseBody.prototype, "total", void 0);
__decorate([
    (0, decorator_1.Field)({
        description: "The records in return.",
        isRequired: true,
        vectorProps: { elementDataType: DataType_1.DataType.OBJECT },
    }),
    __metadata("design:type", Array)
], GetManyResponseBody.prototype, "records", void 0);
GetManyResponseBody = __decorate([
    (0, decorator_1.Data)()
], GetManyResponseBody);
exports.GetManyResponseBody = GetManyResponseBody;
//-- update & delete
let UpdateManyQueries = class UpdateManyQueries extends ReturningQueries {
};
__decorate([
    (0, decorator_1.Field)({
        description: "The fields and corresponding values to filter",
    }),
    __metadata("design:type", Object)
], UpdateManyQueries.prototype, "fields", void 0);
UpdateManyQueries = __decorate([
    (0, decorator_1.Data)({ relaxed: true })
], UpdateManyQueries);
exports.UpdateManyQueries = UpdateManyQueries;
let UpdateManyResponse = class UpdateManyResponse {
};
__decorate([
    (0, decorator_1.Field)({
        description: "Array of ids of modified records",
        isRequired: true,
    }),
    __metadata("design:type", Array)
], UpdateManyResponse.prototype, "modified", void 0);
UpdateManyResponse = __decorate([
    (0, decorator_1.Data)()
], UpdateManyResponse);
exports.UpdateManyResponse = UpdateManyResponse;
let UpdateManyBody = class UpdateManyBody {
    constructor() {
        this.update = {};
    }
};
__decorate([
    (0, decorator_1.Field)({
        description: "Update data",
        isRequired: true,
    }),
    __metadata("design:type", Object)
], UpdateManyBody.prototype, "update", void 0);
UpdateManyBody = __decorate([
    (0, decorator_1.Data)()
], UpdateManyBody);
exports.UpdateManyBody = UpdateManyBody;
let UpdateRecordsBody = class UpdateRecordsBody {
};
UpdateRecordsBody = __decorate([
    (0, decorator_1.Data)()
], UpdateRecordsBody);
exports.UpdateRecordsBody = UpdateRecordsBody;
