"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractLogger = void 0;
const constants_1 = require("../common/constants");
const LogLevel_1 = require("./LogLevel");
class AbstractLogger {
    constructor(limit, logMedia) {
        this.limit = limit;
        this.logMedia = logMedia;
        this.limit = limit;
        this.logMedia = logMedia;
    }
    getLogContext() {
        return this[constants_1.LOG_CONTEXT] || "";
    }
    log(level, content) {
        if (level < this.limit) {
            return "";
        }
        const logContent = this.serializeContent(level, content);
        for (const medium of this.logMedia) {
            medium.write(level, logContent);
        }
        return logContent;
    }
    debug(...content) {
        return this.log(LogLevel_1.LogLevel.DEBUG, content);
    }
    info(...content) {
        return this.log(LogLevel_1.LogLevel.INFO, content);
    }
    warn(...content) {
        return this.log(LogLevel_1.LogLevel.WARN, content);
    }
    error(...content) {
        return this.log(LogLevel_1.LogLevel.ERROR, content);
    }
}
exports.AbstractLogger = AbstractLogger;
